Bug 6819 - Don't offer cancel order links for received order lines on basket summary
Summary: Don't offer cancel order links for received order lines on basket summary
Status: Pushed to master
Alias: None
Product: Koha
Classification: Unclassified
Component: Acquisitions (show other bugs)
Version: master
Hardware: All All
: P5 - low normal (vote)
Assignee: Katrin Fischer
QA Contact: Bugs List
URL: cgi-bin/koha/acqui/basket.pl?basketno=5
Keywords: Academy
Depends on:
Blocks:
 
Reported: 2011-08-30 16:13 UTC by Nicole C. Engard
Modified: 2020-11-13 19:03 UTC (History)
7 users (show)

See Also:
Change sponsored?: ---
Patch complexity: Trivial patch
Text to go in the release notes:
Version(s) released in:
20.11.00


Attachments
basket edit and delete options (67.07 KB, image/png)
2011-08-30 16:13 UTC, Nicole C. Engard
Details
Bug 6819: Hide individual cancel order links when order line has been received (6.12 KB, patch)
2020-10-18 22:58 UTC, Katrin Fischer
Details | Diff | Splinter Review
Bug 26515: Don't need to call safe_to_delete (1.42 KB, patch)
2020-10-19 14:19 UTC, Séverine Queune
Details | Diff | Splinter Review
Bug 6819: Hide individual cancel order links when order line has been received (6.26 KB, patch)
2020-10-19 14:40 UTC, Séverine Queune
Details | Diff | Splinter Review
Bug 6819: Hide individual cancel order links when order line has been received (6.32 KB, patch)
2020-10-21 15:18 UTC, Martin Renvoize
Details | Diff | Splinter Review

Note You need to log in before you can comment on or make changes to this bug.
Description Nicole C. Engard 2011-08-30 16:13:33 UTC
Created attachment 5226 [details]
basket edit and delete options

When you're in a basket you have edit and delete links to the right of each line item (this is good).  The problem is that these options appear even if you have already received an item.  I don't think we need to remove the edit option in this case (but maybe we should) but we certainly should remove the delete option.  If I've received something already then money has been subtracted and deleting a line from a basket could cause major problems.
Comment 1 mathieu saby 2013-09-17 19:03:57 UTC
Nicole, is it still an issue?
If you have received an order, for me that means the basket was closed and send to the vendor. If the basket is closed, you don't see the "delete" and "modify" links in the table.

M. Saby
Comment 2 Nicole C. Engard 2013-09-17 23:46:34 UTC
The basket does not have to be closed to receive items - it's good practice - but it's not required.  So this is still an issue.

Nicole
Comment 3 Katrin Fischer 2013-09-18 04:54:57 UTC
Hm, there are some things that make it more than best practice this days. For example if you want to claim items I think it's important that you have closed the basket (indicating it has been actually ordered). Also if the Acq history search gets pushed this will be get even more important.
Comment 4 mathieu saby 2013-09-18 07:48:45 UTC
Nicole, are you sure you can receive orders in receipt module when the basket is not closed? For me it would look like an issue...

Mathieu
Comment 5 Nicole C. Engard 2013-09-18 18:23:26 UTC
While I say it's required and you all think it's required - Koha  does not require it. I have received many thing when the basket was still open.  Also, you can reopen a basket and delete something you have received. So there are multiple ways to accidentally delete something you have received.
Comment 6 mathieu saby 2013-09-19 19:49:34 UTC
I admit being flexible can be a good thing, but sometimes there's too much way for doing things in Koha... If each library can have its own workflow, it is difficult to ensure code and feature consistency.
OR if there is several way of doing a thing as important as placing an order, it must be syspref dependant.

For me it is strange to have the ability to receive orders when basket is open. Because Koha is calculating late orders on the base of closing basket date (by the way, if basketgroups are used, the closing date of basketgroups should be use instead)

I want to add a new column in the table home page for acquisitions, for orders in non closed baskets (because in my library, they are NOT sent, so they should be in a "prepared orders" column). I can make this syspref dependant of course...

Regarding cancellation : maybe the problem is don't have a quick and easy way to cancel an order once the basket is closed. We need to go on Receipt page, create a invoice or reopen an existing one (even if there is no invoice in real life!), find the order and cancel it.
For our colleagues, it is strange to go in "Receipt" page to cancel an order (like the 'Start' button on Windows to Shut down the computer), and strange to write an invoice number for that.

An other issue : if you cancel an order before closing the basket, for us, it means the librarian changed his mind, and never send this order to the vendor. If we cancel AFER closing the basket, for us it means the vendor was not able to deliver the book. 2 very different things thats Koha manage the same way.

So maybe the solution would be for example
- to improve the way of cancelling ( 2 types of cancellation), and make it more obvious
- to add a syspref for using the date of basket goup closing instead of baskets
- to add a syspref for chosing if orders in open bakets could be received
- to add a syspref for chosing if a basket not put in a basket group is to be considered closed or just in preparation (the case in my library)

Sorry for these long and general remarks, they are not strictly related to the bug...

Mathieu
Comment 7 Katrin Fischer 2019-03-13 07:15:26 UTC
(In reply to Nicole C. Engard from comment #5)
> While I say it's required and you all think it's required - Koha  does not
> require it. I have received many thing when the basket was still open. 
> Also, you can reopen a basket and delete something you have received. So
> there are multiple ways to accidentally delete something you have received.

Apart from standing-order orders it is now required to close the basket in order to receive something from it. You can reopen the basket and cancel something, but it's more secure than it used to be.

That said, I agree that cancelling an order should not be possible for received items. The way should be: undo receive > cancel order.
Comment 8 Ray Delahunty 2020-08-11 09:43:28 UTC
Once the received item is cancelled, the invoice is forever wrong. And it doesn’t just affect EDI invoices, rather all invoices, so a fix to this would be welcome.

We are also wanting to review the opposite- whether it is possible for a cancelled item to be received, but we have to wait. (We are not ordering just now, and are having to set up a new vendor offering EDI, following the demise of our main book supplier.) Like… what does an incoming EDI invoice do when the order it is trying to receive has been cancelled?  Does it force the receive?  It shouldn’t be possible in a manual situation since once cancelled, there is no option for the user to select that order to receive- it would have disappeared from the receive shipment display.
Comment 9 Katrin Fischer 2020-10-18 22:58:35 UTC
Created attachment 111951 [details] [review]
Bug 6819: Hide individual cancel order links when order line has been received

This is to prevent mistakes - a received order should not be
cancelled, but 'undo receive' needs to be done first for things
to turn out correctly.

To test:
- Create a basket with at least 2 orders
- Close basket
- Receive one of your orders at least
- Go back to the basket
- Reopen basket
- The cancel links should only show on the "not received" orders
Comment 10 Séverine Queune 2020-10-19 14:19:05 UTC Comment hidden (obsolete)
Comment 11 Séverine Queune 2020-10-19 14:40:21 UTC
Created attachment 111996 [details] [review]
Bug 6819: Hide individual cancel order links when order line has been received

This is to prevent mistakes - a received order should not be
cancelled, but 'undo receive' needs to be done first for things
to turn out correctly.

To test:
- Create a basket with at least 2 orders
- Close basket
- Receive one of your orders at least
- Go back to the basket
- Reopen basket
- The cancel links should only show on the "not received" orders

Signed-off-by: Séverine QUEUNE <severine.queune@bulac.fr>
Comment 12 Martin Renvoize 2020-10-21 15:18:43 UTC
Created attachment 112106 [details] [review]
Bug 6819: Hide individual cancel order links when order line has been received

This is to prevent mistakes - a received order should not be
cancelled, but 'undo receive' needs to be done first for things
to turn out correctly.

To test:
- Create a basket with at least 2 orders
- Close basket
- Receive one of your orders at least
- Go back to the basket
- Reopen basket
- The cancel links should only show on the "not received" orders

Signed-off-by: Séverine QUEUNE <severine.queune@bulac.fr>
Signed-off-by: Martin Renvoize <martin.renvoize@ptfs-europe.com>
Comment 13 Martin Renvoize 2020-10-21 15:19:06 UTC
Nice improvement, no regresssions.. Passing QA
Comment 14 Jonathan Druart 2020-10-25 23:05:11 UTC
Pushed to master for 20.11, thanks to everybody involved!
Comment 15 Lucas Gass 2020-11-13 19:03:08 UTC
doesnt apply cleanly to 20.05.x, no backport